# coding: utf-8

import six

from huaweicloudsdkcore.utils.http_utils import sanitize_for_serialization


class NodeSelector:

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    sensitive_list = []

    openapi_types = {
        'key': 'str',
        'value': 'list[str]',
        'operator': 'str'
    }

    attribute_map = {
        'key': 'key',
        'value': 'value',
        'operator': 'operator'
    }

    def __init__(self, key=None, value=None, operator=None):
        r"""NodeSelector

        The model defined in huaweicloud sdk

        :param key: 标签键
        :type key: str
        :param value: 标签值列表
        :type value: list[str]
        :param operator: 标签逻辑运算符
        :type operator: str
        """
        
        

        self._key = None
        self._value = None
        self._operator = None
        self.discriminator = None

        self.key = key
        if value is not None:
            self.value = value
        self.operator = operator

    @property
    def key(self):
        r"""Gets the key of this NodeSelector.

        标签键

        :return: The key of this NodeSelector.
        :rtype: str
        """
        return self._key

    @key.setter
    def key(self, key):
        r"""Sets the key of this NodeSelector.

        标签键

        :param key: The key of this NodeSelector.
        :type key: str
        """
        self._key = key

    @property
    def value(self):
        r"""Gets the value of this NodeSelector.

        标签值列表

        :return: The value of this NodeSelector.
        :rtype: list[str]
        """
        return self._value

    @value.setter
    def value(self, value):
        r"""Sets the value of this NodeSelector.

        标签值列表

        :param value: The value of this NodeSelector.
        :type value: list[str]
        """
        self._value = value

    @property
    def operator(self):
        r"""Gets the operator of this NodeSelector.

        标签逻辑运算符

        :return: The operator of this NodeSelector.
        :rtype: str
        """
        return self._operator

    @operator.setter
    def operator(self, operator):
        r"""Sets the operator of this NodeSelector.

        标签逻辑运算符

        :param operator: The operator of this NodeSelector.
        :type operator: str
        """
        self._operator = operator

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                if attr in self.sensitive_list:
                    result[attr] = "****"
                else:
                    result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        import simplejson as json
        if six.PY2:
            import sys
            reload(sys)
            sys.setdefaultencoding("utf-8")
        return json.dumps(sanitize_for_serialization(self), ensure_ascii=False)

    def __repr__(self):
        """For `print`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NodeSelector):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
